##Raster analysis=group
##Correlation=name
##Map1=raster
##Map2=raster
##PercentSampled=number 10
##NullValue=number 0
##showplots

require(raster)

Map1[Map1==NullValue] <- NA
Map2[Map2==NullValue] <- NA

N <- dim(Map1)[1]*dim(Map1)[2]

if (N > 100000) {N <- N * PercentSampled/100}
sample1 <- sampleRegular(Map1,N)
sample2 <- sampleRegular(Map2,N)
plot(sample1,sample2,xlab="Map 1",ylab="Map 2")
print("Pearson Correlation")
Corr <- as.numeric(cor(sample1,sample2,use="complete.obs"))
print(paste0("Pearson = ",Corr))
print("Spearman Correlation")
Corr2 <- as.numeric(cor(sample1,sample2,use="complete.obs",method="spearman"))
print(paste0("Spearman = ",Corr2))