##Flow Matrix=group
##Annual Change Rates=name

##Numer_of_time_points= number

##Land_use_map_t1= raster
##Land_use_map_t2= raster
##Land_use_map_t3= optional raster
##Land_use_map_t4= optional raster
##Land_use_map_t5= optional raster

##Background_value=number 0
##Number_of_years_t1_t2= number
##Number_of_years_t2_t3= optional number
##Number_of_years_t3_t4= optional number
##Number_of_years_t4_t5= optional number

##Annual_change=output table
##Uniform_change=output table
##output_plots_to_html

as.numeric(Numer_of_time_points)

NAvalue(Land_use_map_t1) <- Background_value
NAvalue(Land_use_map_t2) <- Background_value
if (Numer_of_time_points >= 3) {
NAvalue(Land_use_map_t3) <- Background_value
}
if (Numer_of_time_points >= 4) {
NAvalue(Land_use_map_t4) <- Background_value
}
if (Numer_of_time_points >= 5) {
NAvalue(Land_use_map_t5) <- Background_value
}

Crosstabulation <- crosstab(Land_use_map_t1, Land_use_map_t2)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement1 <- Total  - Agreement

Anual_change_raw_1 <- Disagreement1 / Number_of_years_t1_t2
Annual_change_t1_t2 <- (Anual_change_raw_1 / Total)*100

if (Numer_of_time_points >= 3) {
Crosstabulation <- crosstab(Land_use_map_t2, Land_use_map_t3)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement2 <- Total  - Agreement

Anual_change_raw_2 <- Disagreement2 / Number_of_years_t2_t3
Annual_change_t2_t3 <- (Anual_change_raw_2 / Total)*100
}

if (Numer_of_time_points >= 4) {
Crosstabulation <- crosstab(Land_use_map_t3, Land_use_map_t4)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement3 <- Total  - Agreement

Anual_change_raw_3 <- Disagreement3 / Number_of_years_t3_t4
Annual_change_t3_t4 <- (Anual_change_raw_3 / Total)*100
}

if (Numer_of_time_points >= 5) {
Crosstabulation <- crosstab(Land_use_map_t4, Land_use_map_t5)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement4 <- Total  - Agreement

Anual_change_raw_4 <- Disagreement4 / Number_of_years_t4_t5
Annual_change_t4_t5 <- (Anual_change_raw_4 / Total)*100
}

if (Numer_of_time_points == 3) {
NyearsT <- Number_of_years_t1_t2 + Number_of_years_t2_t3
Total_change <- Disagreement1 + Disagreement2

Uniform_line_value <- Total_change / NyearsT

Uniform_change <- (Uniform_line_value / Total)*100

Annual_change <- cbind(Annual_change_t1_t2, Annual_change_t2_t3)
ymax <- (max(Annual_change))*1.5
barplot(Annual_change, main = "Annual Change Rate", ylim=c(0,ymax))
abline(h=Uniform_change)
>Annual_change
>Uniform_change
}

if (Numer_of_time_points == 4) {
NyearsT <- Number_of_years_t1_t2 + Number_of_years_t2_t3 + Number_of_years_t3_t4
Total_change <- Disagreement1 + Disagreement2 + Disagreement3

Uniform_line_value <- Total_change / NyearsT

Uniform_change <- (Uniform_line_value / Total)*100

Annual_change <- cbind(Annual_change_t1_t2, Annual_change_t2_t3, Annual_change_t3_t4)
ymax <- (max(Annual_change))*1.5
>barplot(Annual_change, main = "Annual Change Rate", ylim=c(0,ymax))
abline(h=Uniform_change)
>Annual_change
>Uniform_change
}

if (Numer_of_time_points == 5) {
NyearsT <- Number_of_years_t1_t2 + Number_of_years_t2_t3 + Number_of_years_t3_t4 + Number_of_years_t4_t5
Total_change <- Disagreement1 + Disagreement2 + Disagreement3 + Disagreement4

Uniform_line_value <- Total_change / NyearsT

Uniform_change <- (Uniform_line_value / Total)*100

Annual_change <- cbind(Annual_change_t1_t2, Annual_change_t2_t3, Annual_change_t3_t4, Annual_change_t4_t5)
ymax <- (max(Annual_change))*1.5
>barplot(Annual_change, main = "Annual Change Rate", ylim=c(0,ymax))
abline(h=Uniform_change)
>Annual_change
>Uniform_change
}