##Raster analysis=group
##Intensity Analysis=name
##LULCseries=raster
##NullValue=number 0
##output_plots_to_html
##path=folder 

require(intensity.analysis)


LULCseries[LULCseries==NullValue] <- NA

raster.layers <- as.list(LULCseries)
time.points <- as.character(1:nlayers(LULCseries))
categories <- as.character(sort(unique(as.numeric(values(LULCseries)))))
>print("Cross")
crosstabulation <- multicrosstab(raster.layers, time.points, categories)



>print("Category Level Analysis")
CIA.output <- CIA(crosstabulation, time.points, categories)
filename <- paste0(path,"/CategoryLevel.csv")
CIA2csv(CIA.output,time.points, categories, filename)

>print("Transition Level Analysis")
TIA.output <- TIA(crosstabulation, time.points, categories)
filename <- paste0(path,"/TransitionLevel.csv")
TIA2csv(TIA.output,time.points,categories, filename)

>print("Interval Level Analysis")
IIA.output <- IIA(crosstabulation, time.points)
filename <- paste0(path,"/IntervalLevel.csv")
IIA2csv(IIA.output,time.points, filename)
