##Raster analysis=group
##LUCC Budget=name
##Map_date_1=raster
##Map_date_2=raster
##Cross_tab=output table
##Budget_tab=output table

library("raster")

# Read map resolution
res <- res(Map_date_1)

# Matriz de cambio in hectares
t12 <- crosstab(Map_date_1,Map_date_2,useNA=F,long=T)
names(t12) <- c("d1","d2","Freq")
m12 <- xtabs(Freq~d1 + d2, t12)
m12 <- m12*res[1]*res[2]/10000
> print("*** Cross-tabulation (change) matrix (ha) *** ")
> print(m12)

# Computing of Loss and Gain
m12 <- as.matrix(m12)
sumrow <- rowSums(m12)
sumcol <- colSums(m12)
diag <- diag(m12)
# Loss Pi+ - Pii
Loss <- sumrow - diag
# Gain P+j - Pjj
Gain <- sumcol - diag
# Net change abs(P+j - Pj+)
Net <- abs(sumcol-sumrow)
# swap Sj = 2 x MIN(Pj+ - Pjj , P+j - Pjj)
Swap <- 2*pmin(Gain,Loss)

# Summary table
Cross_tab <- m12
Budget_tab <- data.frame(Gain,Loss,Swap,Net)
> print("*****  LUCC Budget (ha) ******")
> print(Budget_tab)
