##Raster analysis=group
##ROC Analysis=name
##Probability=raster
##Event=raster
##PercentSampled=number 10
##NullValue=number 99
##showplots

library("ROCR")

Event[Event==NullValue] <- NA
Probability[is.na(Event)] <- NA

random <- Event
values(random) <- runif(dim(Event)[1]*dim(Event)[2])

Event[Event==0 & random > PercentSampled/100] <- NA
Probability[Event==0 & random > PercentSampled/100] <- NA

tab <- data.frame(event = getValues(Event),proba=getValues(Probability))
tab <- tab[complete.cases(tab),]

names(tab) <- c("event","proba")

pred <- prediction(tab$proba, tab$event)
perf <- performance(pred,"tpr","fpr")
plot(perf,colorize=F)

perf <- performance(pred,"tpr","fpr",measure="auc")
AUC <- perf@y.values
> print("*********************************")
> print(paste0("AUC = ",AUC))
> print("*********************************")

