##Flow Matrix=group
##Stable and unstable change=name

##Numer_of_time_points= number

##Land_use_map_t1= raster
##Land_use_map_t2= raster
##Land_use_map_t3= optional raster
##Land_use_map_t4= optional raster
##Land_use_map_t5= optional raster

##Background_value=number 0
##Number_of_years_t1_t2= number
##Number_of_years_t2_t3= optional number
##Number_of_years_t3_t4= optional number
##Number_of_years_t4_t5= optional number

##Proportion_of_unstable_change= output table
##Proportion_of_stable_change= output table

as.numeric(Numer_of_time_points)

NAvalue(Land_use_map_t1) <- Background_value
NAvalue(Land_use_map_t2) <- Background_value
if (Numer_of_time_points >= 3) {
NAvalue(Land_use_map_t3) <- Background_value
}
if (Numer_of_time_points >= 4) {
NAvalue(Land_use_map_t4) <- Background_value
}
if (Numer_of_time_points >= 5) {
NAvalue(Land_use_map_t5) <- Background_value
}

Crosstabulation <- crosstab(Land_use_map_t1, Land_use_map_t2)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement1 <- Total  - Agreement

Annual_change_raw_1 <- Disagreement1 / Number_of_years_t1_t2
Annual_change_t1_t2 <- (Annual_change_raw_1 / Total)*100

if (Numer_of_time_points >= 3) {
Crosstabulation <- crosstab(Land_use_map_t2, Land_use_map_t3)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement2 <- Total  - Agreement

Annual_change_raw_2 <- Disagreement2 / Number_of_years_t2_t3
Annual_change_t2_t3 <- (Annual_change_raw_2 / Total)*100
}

if (Numer_of_time_points >= 4) {
Crosstabulation <- crosstab(Land_use_map_t3, Land_use_map_t4)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement3 <- Total  - Agreement

Annual_change_raw_3 <- Disagreement3 / Number_of_years_t3_t4
Annual_change_t3_t4 <- (Annual_change_raw_3 / Total)*100
}

if (Numer_of_time_points >= 5) {
Crosstabulation <- crosstab(Land_use_map_t4, Land_use_map_t5)
nrow <- nrow(Crosstabulation)
as.numeric(nrow)
Categories <- seq(1, nrow, 1)
Total <- sum(Crosstabulation)
XY = 0
for (i in Categories) {
    XY[i] <- Crosstabulation[i, i]
}
Agreement <- sum(XY)
Disagreement4 <- Total  - Agreement

Annual_change_raw_4 <- Disagreement4 / Number_of_years_t4_t5
Annual_change_t4_t5 <- (Annual_change_raw_4 / Total)*100
}

if (Numer_of_time_points == 3) {
NyearsT <- Number_of_years_t1_t2 + Number_of_years_t2_t3
Total_change <- Disagreement1 + Disagreement2

Uniform_line_value <- Total_change / NyearsT

Change_dif_from_unif1 <- Annual_change_raw_1 - Uniform_line_value
Change_dif_from_unif2 <- Annual_change_raw_2 - Uniform_line_value
 
Total_dif_from_unif1 <- abs(Change_dif_from_unif1*Number_of_years_t1_t2)
Total_dif_from_unif2 <- abs(Change_dif_from_unif2*Number_of_years_t2_t3)

Total_variance_from_unif <- Total_dif_from_unif1+Total_dif_from_unif2
Inconsistent_change <- Total_variance_from_unif/2

Proportion_of_unstable_change <- Inconsistent_change / Total_change
Proportion_of_stable_change <- 1 - Proportion_of_unstable_change

>Proportion_of_unstable_change
>Proportion_of_stable_change
}

if (Numer_of_time_points == 4) {
NyearsT <- Number_of_years_t1_t2 + Number_of_years_t2_t3 + Number_of_years_t3_t4
Total_change <- Disagreement1 + Disagreement2 + Disagreement3

Uniform_line_value <- Total_change / NyearsT

Change_dif_from_unif1 <- Annual_change_raw_1 - Uniform_line_value
Change_dif_from_unif2 <- Annual_change_raw_2 - Uniform_line_value
Change_dif_from_unif3 <- Annual_change_raw_3 - Uniform_line_value
 
Total_dif_from_unif1 <- abs(Change_dif_from_unif1*Number_of_years_t1_t2)
Total_dif_from_unif2 <- abs(Change_dif_from_unif2*Number_of_years_t2_t3)
Total_dif_from_unif3 <- abs(Change_dif_from_unif3*Number_of_years_t3_t4)

Total_variance_from_unif <- Total_dif_from_unif1+Total_dif_from_unif2+Total_dif_from_unif3
Inconsistent_change <- Total_variance_from_unif/2

Proportion_of_unstable_change <- Inconsistent_change / Total_change
Proportion_of_stable_change <- 1 - Proportion_of_unstable_change

>Proportion_of_unstable_change
>Proportion_of_stable_change
}

if (Numer_of_time_points == 5) {
NyearsT <- Number_of_years_t1_t2 + Number_of_years_t2_t3 + Number_of_years_t3_t4 + Number_of_years_t4_t5
Total_change <- Disagreement1 + Disagreement2 + Disagreement3 + Disagreement4

Uniform_line_value <- Total_change / NyearsT

Change_dif_from_unif1 <- Annual_change_raw_1 - Uniform_line_value
Change_dif_from_unif2 <- Annual_change_raw_2 - Uniform_line_value
Change_dif_from_unif3 <- Annual_change_raw_3 - Uniform_line_value
Change_dif_from_unif4 <- Annual_change_raw_4 - Uniform_line_value
 
Total_dif_from_unif1 <- abs(Change_dif_from_unif1*Number_of_years_t1_t2)
Total_dif_from_unif2 <- abs(Change_dif_from_unif2*Number_of_years_t2_t3)
Total_dif_from_unif3 <- abs(Change_dif_from_unif3*Number_of_years_t3_t4)
Total_dif_from_unif4 <- abs(Change_dif_from_unif4*Number_of_years_t4_t5)

Total_variance_from_unif <- Total_dif_from_unif1+Total_dif_from_unif2+Total_dif_from_unif3+Total_dif_from_unif4
Inconsistent_change <- Total_variance_from_unif/2

Proportion_of_unstable_change <- Inconsistent_change / Total_change
Proportion_of_stable_change <- 1 - Proportion_of_unstable_change

>Proportion_of_unstable_change
>Proportion_of_stable_change
}